#!/usr/bin/env python
# -*- coding: cp1251 -*-

from time    import localtime, strftime
from sys     import exit
from mod_html_ras import *

import sys, string

#from locale import getlocale, setlocale. LC_TIME
import locale

# from os.path import exists
# from os      import listdir, mkdir
# from string  import atoi
# from shutil  import copytree, copy, move
# import re, os.path

Version = 6.2

nPeople = 4
notMeat = 1

#nDays   = 19.6

locale.setlocale( locale.LC_ALL, '')
print 'Locale --- ', locale.getlocale()

def err( i_str='' ):
    print 'Error: ' + i_str
    raw_input('\nPress any key to finish')
    exit()

def warning( i_str='', i_isKey = False ):
    print 'Warning: ' + i_str
    if i_isKey:
        raw_input('\nPress any key to finish')


def getCurrTime( i_format='%A, %d %b %Y &nbsp;&nbsp; %H:%M:%S' ):
    '     '
    res = strftime( i_format, localtime() )
    return unicode(res, 'cp1251').encode('koi8-r')
    

class  Eda:
    def __init__(self):
        d_count = 1
        d_dict  = {}
        d_name  = ''

    def __init__(self, i_name, i_dict ):
        self.d_name = i_name
        self.d_dict = i_dict        
    

def createEdaTable( i_list ):
    '     (,   )'
    maxLenDict = 0
    for v in i_list:
        if len( v.d_dict ) > maxLenDict:
            maxLenDict = len( v.d_dict )

    SpecTableStart( '#999999', i_cellpadding=3 )
     
    trH = ''
    for v in i_list:
        trH += TD( getB(v.d_name)+ ' ' + blues('(%d)' % v.d_count), i_align='center', i_colspan='3' )
        if v <> i_list[-1]: trH += TD( '&nbsp;', i_bgcolor='#cccccc', i_rowspan='%d' % (maxLenDict + 1) )
    pTR( trH, i_bgcolor='#bbbbbb')
        
    for k in range(0, maxLenDict ):
        trs = ''
        for v in i_list:
            try:
                key = v.d_dict.keys()[k]
                trs += TD( key ) + TD( str(v.d_dict[key]), i_align='right' ) + TD( str(nPeople*v.d_dict[key]), i_align='right' ) 
            except: 
                trs += TD('-', i_align='center', i_colspan='3')
        pTR( trs, i_bgcolor='#dddddd' )    
   
    SpecTableEnd()

def createEdaTable1( i_list ):
    '      (,   )'

    for it in i_list:
        SpecTableStart( '#999999', i_cellpadding=3 )
         
        trH = TD( getB(it.d_name)+ ' ' + blues('(%d)' % it.d_count), i_align='center', i_colspan='3' )
        pTR( trH, i_bgcolor='#bbbbbb')
        
        #print it.d_dict
        for k  in it.d_dict.keys():
            v = it.d_dict[k]
            trs = TD( k ) + TD( str(v), i_align='right' ) + TD( str(nPeople*v), i_align='right' )             
            pTR( trs, i_bgcolor='#dddddd' )    
       
        SpecTableEnd()
        sys.stdout.write( getNB(2) )
    
def getEdaIntegral( i_list, o_integ = {} ):
    '  '

    #o_integ = {}
    for li in i_list:
        for one in li:
            n = one.d_count
            for (k,v) in one.d_dict.items():
                v *= nPeople
                if k in o_integ:
                    massDict = o_integ[k]
                    currN = massDict.get( v, 0 )
                    massDict[v] = currN + n
                else:
                    o_integ[k] = { v:n }

    #print o_integ

def massInfo( i_v = {}):
    '' 
    sum, res = 0, []
    for m, c in i_v.items():
        st = '%dx%s.' % ( c, blues(m)+getNB())
        res.append( st )
        sum += c*m
        
    return  sum, string.join( res, ', ') 

def massInfoCustomData( i_mass, i_tup = () ):
    ''
    (ed, mOne) = i_tup
    return '%7.3g&nbsp;%s  %s&nbsp.' % ( float(i_mass)/mOne, ed, blues('%g' % mOne) )
    
    

def printEdaINtegral( i_integ = {}, i_customData = {}, i_customPrim = {}, i_whatIs = {}, i_nDays=-1 ):
    ' '

    maxItem = 0
    for k, v in i_integ.items():
        if len(v) > maxItem: maxItem = len(v)

    SpecTableStart( '#999999', i_cellpadding=3 )

    trs = TD( '' ) + TD('  ' )+ TD('' )+ TD('' )+ TD('' ) + TD(' ') + TD('') 
    pTR( trs, i_align='center', i_bgcolor='#bbbbbb' )    

    megaSum, estSum, lishSum, nehvaSum = 0,0,0,0
    #for k, v in i_integ.items():
    slist = i_integ.keys()
    slist.sort()
    for k  in slist:#.sort():
        v = i_integ[k]
        sum, st = massInfo(v)
        trs = TD( k.replace(' ','&nbsp;') ) + TD( st, i_align='right' ) + TD( getNB(2)+'%d&nbsp;.' % sum, i_align='right' )            
        tdCD, tdCP = '', ''
        if k in i_customData:
            tdCD = massInfoCustomData( sum, i_customData[k] )
        if k in i_customPrim:
            tdCP = i_customPrim[k]
          
        trs += TD( tdCD, i_align='right', i_wrap='now' ) + TD( tdCP )    

        tdEst, tdLish = '', ''
        if k in i_whatIs:
            est = eval( str( i_whatIs[k]) );  estSum += est
            tdEst = '%d&nbsp' % est
            lish = est-sum                           
            if lish < 0: 
                tdLish = att( lish ) + '&nbsp'; nehvaSum += lish
            else:                
                tdLish= '%d&nbsp' % lish
                lishSum += lish
                
        
        trs += TD( tdEst, i_align='right', i_wrap='now' ) + TD( tdLish, i_align='right', i_wrap='now' )    
        
        pTR( trs, i_bgcolor='#dddddd' )    
        megaSum += sum
   
    trs = TD( ' ' ) + TD( getB(megaSum), i_align='right', i_colspan='2' ) + TD( '', i_colspan='2', i_rowspan='3', i_align='center') + TD( '%s&nbsp;' % getB(estSum) ) + TD('%s&nbsp;' % getB(lishSum))
    pTR( trs, i_bgcolor='#bbbbbb' )    
    trs = TD( ' ' ) + TD( getB(float(megaSum)/nPeople), i_align='right', i_colspan='2' ) + TD( ': %s&nbsp; <br>(  )' % att(getB(nehvaSum)), i_colspan='2', i_rowspan='2', i_align='right') 
    pTR( trs, i_bgcolor='#bbbbbb' )    
    trs = TD( ' ' ) + TD( getB( round( (float(megaSum)/nPeople)/i_nDays) ), i_align='right', i_colspan='2' ) #  + TD( 'z', i_colspan='2', i_align='center') 
    pTR( trs, i_bgcolor='#bbbbbb' )    
     
    SpecTableEnd()
    

def createHtml( i_file, i_list, i_customData, i_customPrim, i_whatIs, i_cot ):
    '  HTML'
    fp = open( i_file, 'wt')
    tmp = sys.stdout
    sys.stdout = fp

    Start()
    StartHead() 
    Title( ' ( 2005)' )
    LinkCSS('fou.css')
    EndHead()
    defBodyColor='#EEEEEE'
    Body( defBodyColor )
    print getBQ()

    print Section(3, ' ') 
   
    liEss = LI(' : ' + getB(Version) + ',  : ' + getB(getCurrTime()))
    liEss += LI(' : ' + getB(str(nPeople)))
    liEss += LI(': ' + getB(str(i_cot[0])))
    liEss += LI(': ' + getB(str(i_cot[1])))
    liEss += LI(': ' + getB(str(i_cot[2])))
    nnDays = float( i_cot[0] + i_cot[1] + i_cot[2] ) / 3 
    liEss += LI(' : ' + getB( '%6.4g' % nnDays ) )
    print List( liEss )

    print Section(3, '    ') 

    for li in i_list:
        createEdaTable( li )
        BR()

    #BR(17)

    print Section(3, '()   ')
    li = LI( getB('') + ' ---    ' )
    li += LI( getB('') + ' ---  ,   ' )
    li += LI( getB('') + ' ---      ' )
    li += LI( getB('') + ' ---      / ' )
    li += LI( getB('') + ' ---      (: '+getB('')+')' )
    li += LI( getB('') + ' ---   '  )
    li += LI( getB('') + ' --- ) ݣ   ., )     ""'  )
    li += LI( getB('') + ' --- ) , ; )   ( . )'  )
    print List( li )
    
    

    print Section(3, '  ') 

    integ = {}
    getEdaIntegral( i_list, integ )
    printEdaINtegral( integ, i_customData, i_customPrim, i_whatIs, nnDays  )
    
    print getBQ(0)
    End()



    sys.stdout = tmp
    #print 'oooooooooooo !! oooooooooooo'
    print '\nooooooo    HTML  oooooooooooooo'.decode('koi8-r')
    fp.close()
    



utro1 = Eda( '_1', {'':70, '':7, '':30, '':15, '.':20, ' ':3} ) 
utro1.d_count = 4
utro2 = Eda( '_2', {' ':75, '':5, '':7, '':30, '':15, ' ':3 } ) 
utro2.d_count = 4
utro3 = Eda( '_3', {'':70, '':5, '':7, '':25, '':20, '.':15, '':12.5} ) 
utro3.d_count = 4
utro4 = Eda( '_4', {'5 ':75, '':5, '':7, '':30, '':15, ' ':3 } ) 
utro4.d_count = 4
utro5 = Eda( '_5', { '':7, '':30, '':30, ' ':3 } ) 
utro5.d_count = 3

uList = ( utro1, utro2, utro3, utro4, utro5 )

obed1 = Eda( '_1', {'':15, '':40, '':45, '':50, 'Finn-Crisp':7, ' ':3 } ) 
obed1.d_count = 4
obed2 = Eda( '_2', {'':15, '':40, '':45, '.':50, 'Finn-Crisp':7, ' ':3 } ) 
obed2.d_count = 4
obed3 = Eda( '_3', {'':15, '/':75, '':50, 'Finn-Crisp':7, ' ':3 } ) 
obed3.d_count = 4
obed4 = Eda( '_4', {'':15, '/':75, '':50, 'Finn-Crisp':7, ' ':3 } ) 
obed4.d_count = 4
obed5 = Eda( '_5', {'':20, '/':60, 'Finn-Crisp':14, ' ':3 } ) 
obed5.d_count = 4

dList = ( obed1, obed2, obed3, obed4, obed5 )

vecher1 = Eda( '_1', {'':70, '':25, '':5, 'Finn-Crisp':7, '':20, ' ':20, ' ':3 } ) 
vecher1.d_count = 12
vecher2 = Eda( '_2', {'':70, '':25, '':5, 'Finn-Crisp':7, '':20, ' ':20, '':10 } ) 
vecher2.d_count = 4
vecher3 = Eda( '_3', {'':70, 'Finn-Crisp':14, '':15, ' ':3 } ) 
vecher3.d_count = 4

vList = ( vecher1, vecher2, vecher3 )

voob1 = Eda( '_1', {
        '' :  5,
        ''    : 10,
        ''       :  9,
        ''     :  1.2,
        ''      :  0.5,
        ''     :  2,
        ''     :  0.5,
        'Zuko'       :  0.7 
        })
voob1.d_count = 20

voob2 = Eda( '_2', {
        ''     : 11,
        ''      : 28
        })
voob2.d_count = 7

voob3 = Eda( '', {
        ''        : 15,
        ' .'  : 15,
        ''        : 15,
        ''         : 15,
        })
voob3.d_count = 5

edyList = [ uList, dList, vList, (voob1,voob2, voob3) ]

customData = {
'Finn-Crisp' : ( '.',  7   ),
''     : ( '.',  7   ),
''      : ( '.', 5.5 ),
'/'        : ( '.', 60  ),
''      : ( '.', 250 ),
'Zuko'       : ( '',   30 )
#'' : ( '', ),
#'' : ( '', ),
#'' : ( '', ),
}

customPrim = {
'' : '%d/%d --- , %d/%d --- ' % (nPeople-notMeat, nPeople, notMeat, nPeople),
' '   : ': ۣ   . ',
'' : ' ()',
''   : ' (5), . (5), <br> (3),  (4),  (3)',
''   : '  ', #' ? ?   ',
''  : ' ',
''   : '  ',
''    : ' ,  ',
'Finn-Crisp' : ' ,    ģ',
'/'        : ' <>',
'5 ': '   ',
''     : ' ',
'.'    : ' ',
''     : '    ',
#'' : '',
}


utCo, obCo, veCo = 0,0,0
for u in uList:  utCo += u.d_count
for u in dList:  obCo += u.d_count
for u in vList:  veCo += u.d_count

cot = (utCo, obCo, veCo)

whatIs = {
#'. ' : '300+10*25',
#'ۣ .'  : 906,
' '         : '300+10*25+906',
''         : 4400,
''       : 1600,
#'5 '   : 500,
''        : 1000,
''         : 1300,
''        : 250,
''         : 750,
' '   : 1600,
''         : 1000,
''       : 800,
''       : '15*75',
''           : 2230,
''        : 400,
' .'  : 400,
''        : 1400,
''        : '3*15',
'Zuko'          : '3*30',
''        : '3*15',
''        : '10+10+30',
''         : 900,
''    : 500,
}



createHtml( 'ras_chu.htm', edyList, customData, customPrim,  whatIs, cot)

fin = '\n ӣ .   ...'
raw_input( unicode(fin, 'koi8-r').encode('cp866') )
