#!/usr/bin/env python
#-*- coding: koi8-r -*-

import sys
import locale 
from time    import localtime, strftime
from sys     import exit
from mod_html_ras import *

Version = 1.0

locale.setlocale( locale.LC_ALL, '')
print 'Locale --- ', locale.getlocale()

def tr( i_str = '' ):
    return unicode(i_str, 'koi8-r').encode('cp866')

def err( i_str='' ):
    print 'Error: ' + i_str
    raw_input('\nPress any key to finish')
    exit()

def warning( i_str='', i_isKey = False ):
    print 'Warning: ' + i_str
    if i_isKey:
        raw_input('\nPress any key to finish')


def getCurrTime( i_format='%A, %d %b %Y &nbsp;&nbsp; %H:%M:%S' ):
    '     '
    res = strftime( i_format, localtime() )
    return unicode(res, 'cp1251').encode('koi8-r')


dictEdaFact =  { 
'' : [
( '',      ' 3' , 370), 
( '',      ' 4' , 470), 
( '',      ' 3' , 340), 
( '',      ' 3' , 330), 
( '',      ' 3' , 340), 
( '',      '.. 4,  4' , 670 ), 
( '',      '... 1,  1' , 590), 
( '',      ', ' , 580), 
( '',      '.. 4,  4' , 680 ), 
( '',      ', ' , 590), 
( '',      ', ' , 590), 
( '',      '... 1,  1' , 590), 
( '',      ' 3' , 870), 
( '',      '.. 1,  1' , 590), 
( '',      '.. 1,  1' , 590), 
( '',      '.. 1,  1' , 590), 
( '', '1' , 302), 
( '', '2' , 302), 
( '', '3' , 302), 
( '-',      ''  , 544), 
],
'' : [
( '-',          'Finn Crisp' , 210), 
( '-',          'Finn Crisp' , 210), 
( '-',          'Finn Crisp' , 220), 
( '',       ''             , 800), 
( '',          ' 1'         , 970), 
( '',          ' 1.2'       , 1160), 
( '',          ' 1.2'       , 1230), 
( 'MGK RIJEKA', ''              , 420), 
( ' ', ' '   , 398), 
( '/',        ' '        , 3480),
( '-',          '  ' , 154), 
( '',   ' '           , 40),
( 'Coffee',     ' ̣'       , 174),
( 'S',          ' 4,  5', 536),
( '',          ' 50'         , 318), 
( '-',          'Finn Crisp (  )' , 210), 
( '-',          'Finn Crisp (  )' , 210), 
( '-',          ' (  )' , 254), 
],
'' : [
( '',  ' ' , 242), 
( '',   '' , 234), 
( '',       ' ' , 590), 
( '',       ' ' , 590), 
( '',       ' ' , 600), 
( '',       ' ' , 590), 
( '',       ' 26' , 190), 
( '',       ' 4+4' , 590), 
( '',       ' ' ,        290), 
( '',       '5  12' , 610 ), 
( '',       '5  12' , 600 ), 
( '',       '  12' , 660), 
( '',       '  12' , 680),
( '',   '' , 2230),
( '',       ' ̣' , 216),
],
'' : [
( '', '2 2 2'     , 640 ), 
( '', ', , Zuko'  , 870), 
( '', ' , '     , 680), 
( '', ' 4' , 870), 
( '', ' 2,  1' , 510), 
( '', ' 2,  1' , 510), 
( '', ' 8' , 680 ), 
( '', '' , 620), 
( '', '' , 410), 
( '', '' , 370), 
( '', '' , 180), 
( '', '2 2, , 2' , 870), 
( '', ' 800' , 870), 
( '', 'Finn Crisp' , 230), 
( '-', '' , 960), 
( '-', ' ()' , 356), 
# '' : ('', ), 
]}

dictSnarFact = {
'' : [
( '-', ''     , 5600 ), 
( '-', '  '  , 170), 
( '-', ' '  , 400), 
( '-', ''  , 1000), 
],
'' : [
( '-', 'ң 4   30 '  , 380), 
( '-', 'ң 6   8 '  , 210), 
( '-', 'ң 6   10 '  , 270), 
( '-', ' 3 '  , 250 ), 
( '-', ' 30 '  , 700), 
( '-', ''  , 250), 
( '-', ''  , 320), 
( '-', ' 13'  , 3600), 
( '-', ' + '  , 610),
],
'' : [
( '-', ''  , 330), 
( '-', ' (, , , , .,<br>,  5, , , ţ, )'  , 1900), 
( '-', ' (, ̣, )'  , 740), 
( '-', ''  , 470), 
( '-', ''  , 120), 
( '-', ''  , 140), 
( '-', ' (, , )'  , 600), 
( '-', ' '  , 1520), 
],
'' : [
( '-', ''  , 7600), 
( '-', 'GPS'  , 350), 
]}



def prostoSumma( i_list=[] ):
    'dfsdfsd'
    summa = 0
    for v in i_list:
        summa += v[2]
        #print k, summa
    return int(summa)

print 3*'\n'

edaSumma, snarSumma = 0,0
for k, v in dictEdaFact.items():
    edaOne = prostoSumma(v)
    snarOne = prostoSumma( dictSnarFact[k] )
    print '%6s = %6d,  %6d' % ( tr(k), edaOne, snarOne )
    #print '%6s = %6d,  %6d' % (unicode(k,'koi8-r').encode('cp866'), edaOne, snarOne )
    edaSumma  += edaOne
    snarSumma += snarOne
    
nPeo = len(dictEdaFact)    
edaAvr  = edaSumma / float(nPeo)
snarAvr = snarSumma / float(nPeo)

print '-----------------------------'
print ' GENER = %6d,  %6d, %6d' % (edaSumma, snarSumma, edaSumma + snarSumma)
print '   AVR = %6d,  %6d, %6d' % (edaAvr, snarAvr, edaAvr + snarAvr )


#=====================================================

def createGeneralItog( i_dictEda, i_dictSnar ):
    '  '

    SpecTableStart( '#999999', i_cellpadding=3 )

    trH = TD( getB('') ) + TD( getB(', ')) + TD( getB(', ')) + TD( getB(' + , '))
    pTR( trH, i_bgcolor='#bbbbbb', i_align='center')
    
    edaSumma, snarSumma = 0,0
    for k, v in i_dictEda.items():
        edaOne = prostoSumma(v)
        snarOne = prostoSumma( i_dictSnar[k] )
        trs = TD(k, i_align='left') + TD(edaOne) + TD(snarOne)+ TD(edaOne + snarOne)
        pTR( trs, i_bgcolor='#dddddd', i_align='right' )   

        edaSumma  += edaOne
        snarSumma += snarOne

    nPeo = len(dictEdaFact)    
    edaAvr  = edaSumma / float(nPeo)
    snarAvr = snarSumma / float(nPeo)

    trs = TD('', i_align='left') + TD(edaSumma) + TD(snarSumma)+ TD(edaSumma + snarSumma)
    pTR( trs, i_bgcolor='#dddddd', i_align='right' )   

    trs = TD(' ', i_align='left') + TD(edaAvr) + TD(snarAvr)+ TD(edaAvr + snarAvr)
    pTR( trs, i_bgcolor='#dddddd', i_align='right' )   
   
    SpecTableEnd()
    return
    


def createOneItogTable( i_list, i_name ):
    '    '

    SpecTableStart( '#999999', i_cellpadding=3 )
     
    trH = TD( getB(i_name), i_colspan='4', i_align='center' )
    #pTR( trH, i_bgcolor='#bbbbbb')
    trH = TD( getB('') ) + TD( getB('')) + TD( getB('')) + TD( getB(''), i_width='400')
    pTR( trH, i_bgcolor='#bbbbbb', i_align='center')
    
        
    for v in i_list:
        trs = TD( v[0] ) + TD( v[1] ) + TD( v[2], i_align='right' ) + TD('')
        pTR( trs, i_bgcolor='#dddddd' )   

    trs = TD( ' %s' % getB(len(i_list)), i_colspan='2'  ) + TD( getB(prostoSumma(i_list)), i_align='right' ) + TD()       
    pTR( trs, i_bgcolor='#bbbbbb' )   
   
    SpecTableEnd()


def createHtml( i_file ):
    '  HTML '
    fp = open( i_file, 'wt')
    tmp = sys.stdout
    sys.stdout = fp

    Start()
    StartHead() 
    Title( '   ( 2005)' )
    LinkCSS('fou.css')
    EndHead()
    defBodyColor='#EEEEEE'
    Body( defBodyColor )
    print getBQ()

    print Section(3, ' ') 
   
    liEss = LI(' : ' + getB(Version) + ',  : ' + getB(getCurrTime()))
    print List( liEss )

    print Section(3, '   ӣ')
    print '<ul>'

    for k, v in dictEdaFact.items():
        print LI(getB(k))
        createOneItogTable( v, k )
        BR()
    print '</ul>'        

    #BR(17)

    print Section(3, '   ') 

    print '<ul>'
    for k, v in dictSnarFact.items():
        print LI(getB(k))
        createOneItogTable( v, k )
        BR()
    print '</ul>'        

    print Section(3, '') 
    createGeneralItog( dictEdaFact, dictSnarFact )

    
    print getBQ(0)
    End()


    sys.stdout = tmp
    print '\nooooooo    HTML  oooooooooooooo'.decode('koi8-r')
    print tr('\nooooooo    HTML  oooooooooooooo')
    fp.close()



createHtml( 'itogo.htm' )














raw_input('\n\n --------->>>>>>>>> Press')
